----------------------------------
-- RESURECTION MONITOR
----------------------------------
local colors = {
	green = {0,1,0},
	orange = {1,0.51,0},
	red = {1,0,0}
}

function HealInc:ResComm_ResStart(event, resser, endTime, targetName)  
    if self.res[resser] then return end;
   
    self.res[resser] = {
                            endTime = endTime,
                            target = targetName
                        }
    
    self:StartResBar(resser);
    
    self:UpdateResColors();
end

function HealInc:ResComm_ResEnd(event, resser, target)
    if not self.res[resser] then return end;
      
    self:StopResBar(resser);
    
    self.res[resser] = nil;
    
    self:UpdateResColors();
end

function HealInc:ResComm_Ressed(event, ressed)
    if not self.ressed[ressed] or ((self.ressed[ressed] + 120) < GetTime()) then
                self.ressed[ressed] = GetTime();
    end
            
    self:UpdateResColors();
end

----------------------------------
--- Functions from events
----------------------------------
function HealInc:StartResBar(resser)
    if not self.db.profile.resmon then return end
    
    local info = self.res[resser];
    local id = "HealInc-res-"..resser;
    
    local time = info.endTime - GetTime();
    
    bartext = self:ClassTextColor(resser,select(2, UnitClass(resser)))..
              " is resurrecting "..
              self:ClassTextColor(info.target,select(2, UnitClass(info.target)))
 
	local bar = self.res_bars:NewTimerBar(id, bartext, time, nil, "Interface\\Icons\\Spell_Holy_Resurrection", 0)
	r,g,b = unpack(colors.green)
    bar:SetBackgroundColor(r,g,b,1)
	
    bar:SetColorAt(0,0,0,0,1.0)
    -- register bar id and status
    self.res[resser].bar = bar;
end

function HealInc:StopResBar(resser)
    if not self.db.profile.resmon then return end
        
    if not self.res[resser] then return end;

	self.res[resser].bar:Fade(0.5)
end
----------------------------------
--- Color status. Checks for overlaping resses
----------------------------------

function HealInc:UpdateResColors()
    if not self.db.profile.resmon then return end
    
    local currentRes = {}
    local beingRessed = {}
    local duplicate = false;
    
    for healerName,info in pairs(self.res) do
        table.insert(currentRes,info);
    end
    
    table.sort(currentRes,function(a,b) return a.endTime < b.endTime end);
    
    for index,info in pairs(currentRes) do
        
        duplicate = false;
        alreadyressed = false;
        
        for i, ressed in pairs(beingRessed) do
            if(ressed == info.target) then
                r,g,b = unpack(colors.red)
				info.bar:SetBackgroundColor(r,g,b,1)
                duplicate = true;
                break;
            end
        end
        
        for ressed, time in pairs(self.ressed) do
            if (ressed == info.target) and (time + 120) > GetTime() then
                r,g,b = unpack(colors.orange)
				info.bar:SetBackgroundColor(r,g,b,1)  
                alreadyressed = true;
                break;
            end
        end                
        
        if not duplicate and not alreadyressed then
            r,g,b = unpack(colors.green)
            info.bar:SetBackgroundColor(r,g,b,1)
            table.insert(beingRessed,info.target);
        end
    end   
end

function HealInc:Debug()
	HealInc:ResComm_Ressed(nil, "Idiot")
	HealInc:ResComm_ResStart(nil, "Resser", GetTime() + 10, "Idiot")
	HealInc:ResComm_ResStart(nil, "Foo", GetTime() + 3, "Idiot")
end
